]> git.pld-linux.org Git - packages/mysql.git/blob - mysql.init
- update files (partial)
[packages/mysql.git] / mysql.init
1 #!/bin/sh
2 #
3 # mysql         A very fast and reliable SQL database engine
4 #
5 # chkconfig:    2345 84 25
6 #
7 # description:  A very fast and reliable SQL database engine.
8
9 # Source function library
10 . /etc/rc.d/init.d/functions
11
12 # Get network config
13 . /etc/sysconfig/network
14
15 # Get service config
16 if [ -f /etc/sysconfig/mysql ]; then
17         . /etc/sysconfig/mysql
18 else
19         nls "Error: %s not found" /etc/sysconfig/mysql
20         nls "%s can't be run." MySQL
21         exit 1
22 fi
23
24 if [ -n "$MYSQL_DB_CLUSTERS" ]; then
25         nls "Warning: MYSQL_DB_CLUSTERS is set. It's obsolete. Use %s instead." /etc/mysql/clusters.conf
26 fi
27
28 if [ -f /etc/mysql/clusters.conf ]; then
29         MYSQL_DB_CLUSTERS=$(awk -F= '!/^#/ && /=/{print $2}' /etc/mysql/clusters.conf)
30         if [ -z "$MYSQL_DB_CLUSTERS" ]; then
31                 nls "Warning: there are no configured clusters."
32         fi
33
34 else
35         nls "Warning: Missing clusters config file %s" /etc/mysql/clusters.conf
36         if [ -z "$MYSQL_DB_CLUSTERS" ]; then
37                 nls "Warning: there are no configured clusters."
38                 nls "Using default cluster /var/lib/mysql (compatibility mode)"
39                 MYSQL_DB_CLUSTERS=/var/lib/mysql
40         fi
41 fi
42
43
44 # Check that networking is up
45 if is_yes "${NETWORKING}"; then
46         if [ ! -f /var/lock/subsys/network -a "$1" != stop -a "$1" != status -a "$1" != init ]; then
47                 msg_network_down MySQL
48                 exit 1
49         fi
50 else
51         exit 0
52 fi
53
54 sharedir=/usr/share/percona-server
55
56 action="$1"
57
58 # any db cluster as command line argument?
59 if [ $# -gt 1 ]; then
60         shift
61         # perform action for specified clusters only
62         for a in "$@"; do
63                 # try auto resolving from /etc/mysql/clusters.conf
64                 if [[ "$a" != /* ]]; then
65                         m=$(awk -va="$a" -F= 'substr($0, 1, length(a)) == a {print $1}' /etc/mysql/clusters.conf)
66                         if [ -z "$m" ]; then
67                                 echo >&2 "Cluster name '$a' did not match anything!"
68                                 exit 1
69                         fi
70                         if [ $(echo "$m" | wc -l) -gt 1 ]; then
71                                 echo >&2 "Cluster name '$a' ambiguous:" $m
72                                 exit 1
73                         fi
74                         a=$(awk -va="$a" -F= 'substr($0, 1, length(a)) == a {print $2}' /etc/mysql/clusters.conf)
75                 fi
76                 DB_CLUSTERS="$DB_CLUSTERS $a"
77         done
78 else
79         DB_CLUSTERS="$MYSQL_DB_CLUSTERS"
80 fi
81
82 # global error log, if mysqld.conf hasn't migrated to log-error style
83 MYSQL_ERRLOG=/var/log/mysql/mysqld.log
84 MYSQL_STOP_WAIT_TIME=${MYSQL_STOP_WAIT_TIME:-900}
85
86 #
87 # Useful functions.
88 #
89
90 #
91 # check for mysql status
92 #
93 # arguments:
94 # $1 - db cluster
95 # $2 - start|stop
96 #
97 # sets variables:
98 # MYSQL_STATUS = starting | running | not running | died
99 # MYSQL_PID    = pid of mysqld process
100 #
101 mysqlstatus() {
102         clusterdir="$1"
103         mode="$2"
104         
105         mysqlgetconfig "$clusterdir" status
106
107         MYSQL_STATUS="not running"
108         MYSQL_PID="unknown"
109         MYSQL_PIDFILE_PID=""
110         MYSQL_GREP_PID=""
111
112         if [ -f "$MYSQL_PIDFILE" ]; then
113                 MYSQL_PIDFILE_PID=$(cat "$MYSQL_PIDFILE")
114         fi
115         
116         if [ -n "$MYSQL_PIDFILE_PID" ]; then
117                 MYSQL_PID=$MYSQL_PIDFILE_PID
118                 if [ ! -d "/proc/$MYSQL_PID" ]; then
119                         MYSQL_STATUS="died"
120                         return
121                 elif (grep -qa "$MYSQL_PIDFILE" /proc/$MYSQL_PID/cmdline 2> /dev/null); then
122                         MYSQL_STATUS="running"
123                         return
124                 fi
125         fi
126
127         if [ "$mode" = "start" ]; then
128                 MYSQL_GREP_PID=$(grep -alE "^/usr/sbin/mysqld.*${MYSQL_PIDFILE}" /proc/[0-9]*/cmdline 2> /dev/null | awk -F "/" '{ print $3; exit; }')
129                 if [ -n "$MYSQL_GREP_PID" ]; then
130                         MYSQL_PID=$MYSQL_GREP_PID
131                         if grep -qa "$MYSQL_PIDFILE" /proc/$MYSQL_PID/cmdline 2> /dev/null; then
132                                 if [ -f "$MYSQL_PIDFILE" ]; then
133                                         MYSQL_PIDFILE_PID=$(cat "$MYSQL_PIDFILE")
134                                 fi
135                                 if [ -n "$MYSQL_PIDFILE_PID" ]; then
136                                         MYSQL_PID=$MYSQL_PIDFILE_PID
137                                         MYSQL_STATUS="running"
138                                         return
139                                 else
140                                         MYSQL_STATUS="starting"
141                                         return
142                                 fi
143                         fi
144                 fi
145         fi
146
147         # else default, "not running"
148 }
149
150 # get mysql configuration in variables
151 # MYSQL_CONFIG MYSQL_CLUSTER_DIR
152 # MYSQL_DATA_DIR MYSQL_USER MYSQL_PIDFILE MYSQL_SOCKET MYSQL_PORT MYSQL_BIND_ADDRESS MYSQL_SKIP_NETWORKING MYSQL_LOG_ERROR
153 #
154 # arguments
155 # $1 - db cluster
156 # $2 - status | other
157
158 mysqlgetconfig() {
159         local clusterdir="$1" config_file
160         local mode="$2"
161
162         # emulate old behaviour if only one cluster specified
163         if [ "$clusterdir" = "$MYSQL_DB_CLUSTERS" -a "$clusterdir" = "/var/lib/mysql" -a -f /etc/mysqld.conf ]; then
164                 MYSQL_RA_COMPAT=yes
165                 config_file=/etc/mysqld.conf
166         else
167                 local config=$(awk -F= -vclusterdir="$clusterdir" '!/^#/{ if (clusterdir == $2) print $1}' /etc/mysql/clusters.conf)
168                 if [[ $config = /* ]]; then
169                         config_file="$config"
170                 elif [ -f "/etc/mysql/$config" ]; then
171                         config_file="/etc/mysql/$config"
172                 else
173                         config_file="$clusterdir/mysqld.conf"
174                 fi
175         fi
176
177         MYSQL_CLUSTER_DIR="$clusterdir"
178
179         if [ -z "$config_file" ]; then
180                 nls "Error: Can't find config file for %s cluster" "$clusterdir"
181                 if [ "$mode" = "status" ]; then 
182                         exit 3
183                 else
184                         exit 6
185                 fi
186         else
187                 MYSQL_CONFIG="$config_file"
188         fi
189
190         if [ ! -f "$config_file" ]; then
191                 nls "Error: config file %s not found" "$config_file"
192                 nls "MySQL can't be run. Did you initialize DB by doing \`$0 init'?"
193                 if [ "$mode" = "status" ]; then 
194                         exit 3
195                 else
196                         exit 6
197                 fi
198         fi
199
200         # reset to initial state
201         MYSQL_DATA_DIR= MYSQL_USER= MYSQL_PIDFILE= MYSQL_SOCKET= MYSQL_PORT= MYSQL_BIND_ADDRESS= MYSQL_SKIP_NETWORKING= MYSQL_LOG_ERROR=
202
203         eval `awk -F= '
204         {
205                 # undos
206                 gsub(/\r$/, "");
207
208                 # trim spaces
209                 gsub(/^[\t ]+|[\t ]+$/, "", $1);
210                 gsub(/^[\t ]+|[\t ]+$/, "", $2);
211         }
212
213         # skip comments and empty lines
214         /^[;#]|^ *$/ { next }
215
216         /^[ \t]*\[.*\][ \t]*$/ {
217                 match($0, /\[.*\]/);
218                 section = substr($0, RSTART + 1, RSTART + RLENGTH - 3);
219                 next;
220         }
221
222         section == "mysqld" {
223                 if ($1 == "datadir") {
224                         printf("MYSQL_DATA_DIR=%s;", $2);
225                 } else if ($1 == "user") {
226                         printf("MYSQL_USER=%s;", $2);
227                 } else if ($1 == "pid-file") {
228                         printf("MYSQL_PIDFILE=%s;", $2);
229                 } else if ($1 == "socket") {
230                         printf("MYSQL_SOCKET=%s;", $2);
231                 } else if ($1 == "port") {
232                         printf("MYSQL_PORT=%s;", $2);
233                 } else if ($1 == "bind-address") {
234                         printf("MYSQL_BIND_ADDRESS=%s;", $2);
235                 } else if ($1 == "skip-networking") {
236                         printf("MYSQL_SKIP_NETWORKING=1;");
237                 } else if ($1 == "log-error") {
238                         printf("MYSQL_LOG_ERROR=%s;", $2);
239                 }
240         }
241         ' $config_file`
242
243         # error log not defined in config file. add one
244         if [ -z "$MYSQL_LOG_ERROR" ]; then
245                 MYSQL_LOG_ERROR=$MYSQL_ERRLOG
246         else
247                 # unset, so mysqld would use value from config itself
248                 unset MYSQL_LOG_ERROR
249         fi
250
251         if is_yes "$MYSQL_RA_COMPAT"; then
252                 MYSQL_DATA_DIR_SUB=""
253         else
254                 MYSQL_DATA_DIR_SUB="/mysqldb"
255         fi
256
257         if [ -z "$MYSQL_DATA_DIR" -o "$MYSQL_DATA_DIR" != "${clusterdir}${MYSQL_DATA_DIR_SUB}/db" ]; then
258                 nls "Error: datadir specified in %s should be %s" "$config_file" "$clusterdir${MYSQL_DATA_DIR_SUB}/db"
259                 nls " MySQL can't be run."
260                 exit 6
261         fi
262
263         if [ -z "$MYSQL_PIDFILE" -o "$MYSQL_PIDFILE" != "$clusterdir${MYSQL_DATA_DIR_SUB}/mysql.pid" ]; then
264                 nls "Error: pid-file specified in %s should be %s" "$config_file" "$clusterdir${MYSQL_DATA_DIR_SUB}/mysql.pid"
265                 nls " MySQL can't be run."
266                 exit 6
267         fi
268
269         if [ -z "$MYSQL_USER" ]; then
270                 echo "$(nls 'MySQL user not configured properly')"'!' >&2
271                 nls "Edit %s and configure it." "$config_file" >&2
272                 exit 6
273         fi
274 }
275
276 # start mysql
277 mysqlstart() {
278         local clusterdir="$1"
279         mysqlgetconfig "$clusterdir"
280         if [ ! -d "$MYSQL_DATA_DIR/mysql" ]; then
281                 nls "MySQL cluster %s not initialized." "$clusterdir"
282                 nls "Try \`%s init %s' before start." "$0" "$clusterdir"
283                 exit 6
284         fi
285
286         msg_starting "MySQL $clusterdir"; busy
287         [ -z "$DEFAULT_SERVICE_RUN_NICE_LEVEL" ] && DEFAULT_SERVICE_RUN_NICE_LEVEL=0
288         rm -f "$MYSQL_PIDFILE"
289
290
291         TMPDIR=/tmp nice -n ${SERVICE_RUN_NICE_LEVEL:-$DEFAULT_SERVICE_RUN_NICE_LEVEL} \
292                 /usr/bin/setsid /usr/sbin/mysqld \
293                         --defaults-file=$MYSQL_CONFIG \
294                         --datadir=$MYSQL_DATA_DIR \
295                         --pid-file=$MYSQL_PIDFILE \
296                         ${MYSQL_LOG_ERROR:+--log-error="$MYSQL_LOG_ERROR"} \
297                         $MYSQL_OPTIONS &
298         pid=$!
299
300         sleep 0.1
301         mysqlstatus "$clusterdir" start
302         # it takes longer for mysqld to start and create pidfile if it has to recover innodb transactions
303         if [ "$MYSQL_STATUS" = "starting" ]; then
304                 echo ""
305                 show "Waiting for MySQL to start"
306                 busy
307
308                 # while the pid is running, mysql is starting up
309                 # if the pidfile was created, it started up successfully
310                 # if either case fails we break and report status
311                 while true; do
312                         [ -d /proc/$pid ] || break
313                         [ -f "$MYSQL_PIDFILE" ] && break
314                         sleep 0.2
315                 done
316         fi
317
318         mysqlstatus "$clusterdir" start
319         if [ "$MYSQL_STATUS" = "running" -a "$MYSQL_PID" != "unknown" ]; then
320                 ok
321         elif [ "$MYSQL_STATUS" = "died" ]; then
322                 RETVAL=1
323                 died
324         else
325                 RETVAL=1
326                 fail
327         fi
328 }
329
330 # stop mysql
331 mysqlstop() {
332         local clusterdir="$1"
333         mysqlstatus "$clusterdir" stop
334         msg_stopping "MySQL $clusterdir"
335         busy
336
337         # try graceful shutdown -- send shutdown command
338         # requires mysql_sysadmin user proper privs
339         /usr/bin/mysqladmin --defaults-file=$MYSQL_CONFIG ${MYSQL_SOCKET:+--socket=$MYSQL_SOCKET} shutdown >/dev/null 2>&1
340         mysqlstatus "$clusterdir" stop
341
342         if [ "$MYSQL_PID" != "unknown" ]; then
343                 kill -TERM "$MYSQL_PID" 2> /dev/null
344                 for nr in $(seq 1 $(($MYSQL_STOP_WAIT_TIME*10))); do
345                         [ -d "/proc/$MYSQL_PID" ] || break
346                         sleep 0.1
347                 done
348         fi
349         
350         mysqlstatus "$clusterdir" stop
351         if [ "$MYSQL_STATUS" = "died" ]; then
352                 died
353         elif [ "$MYSQL_STATUS" = "running" -o "$MYSQL_STATUS" = "starting" ]; then
354                 fail
355         else
356                 ok
357         fi
358 }
359
360 # report slave status
361 # uses MYSQL_SOCKET - path to mysql socket
362 slave_status() {
363         if [ ! -x /usr/bin/mysql ]; then
364                 echo >&2 "Slave status not available: 'mysql' program not installed."
365                 return
366         fi
367
368         # see if slave status can be reported
369         local err=0 slave_status=$(mysql --defaults-file="$MYSQL_CONFIG" --socket="$MYSQL_SOCKET" -e 'show slave status\G')
370         if [ -z "$slave_status" ]; then
371                 # slave not setup
372                 return
373         fi
374
375         printf "Slave Status:\n"
376
377         set -f
378         eval $(echo "$slave_status" | awk -F': ' '/^ *[A-Za-z_]+:/{
379                 k = tolower($1);
380                 v = substr($0, length($1) + 3);
381                 gsub(/\\/, "\\\\\\", v);
382                 gsub(/"/, "\\\"", v);
383                 gsub(/`/, "\\`", v);
384                 gsub(/\$/, "\\$", v);
385                 gsub(/\$/, "\\$", v);
386                 printf("%s=\"%s\";\n", k, v);
387         }')
388         set +f
389
390         if [ "$slave_io_running" != "Yes" ]; then
391                 printf "\tSlave IO not running\n"
392                 err=1
393         fi
394         if [ "$slave_sql_running" != "Yes" ]; then
395                 printf "\tSlave SQL not running\n"
396                 err=1
397         fi
398
399         if [ "$err" = 1 -a "$last_errno" -gt 0 ]; then
400                 printf "\tERROR %s: %s\n" "$last_errno" "$last_error"
401         fi
402
403         if [ "$master_log_file" != "$relay_master_log_file" ]; then
404                 printf "\tERROR logfile mismatch (%s)\n" "$relay_master_log_file"
405                 err=1
406         fi
407
408         if [ -z "$read_master_log_pos" -o -z "$exec_master_log_pos" ]; then
409                 printf "\tERROR No info about master\n"
410                 err=1
411                 return
412         fi
413
414         diff=$(($read_master_log_pos - $exec_master_log_pos))
415         printf "\tread pos: %s (%s) (host: %s:%d)\n" "$read_master_log_pos" "$master_log_file" "$master_host" "$master_port"
416         printf "\texec pos: %s\n" "$exec_master_log_pos"
417         printf "\tdiff: %s\n" "$diff"
418 }
419
420 #
421 # check for running mysql instances; if any instance is running then
422 # create subsys lock file
423 #
424 mysqlsubsys() {
425         # check for every defined db cluster in sysconfig file
426         for mysqldir in $DB_CLUSTERS; do
427                 mysqlstatus "$mysqldir"
428                 if [ "$MYSQL_STATUS" = "running" ]; then
429                         touch /var/lock/subsys/mysql
430                         return
431                 fi
432         done
433         rm -f /var/lock/subsys/mysql
434 }
435
436 mysqlinit() {
437         local clusterdir="$1"
438
439         if [ -f /etc/mysqld.conf ]; then
440                 nls "Running in \`no cluster compat' mode: can't initialize database."
441                 nls "Move /etc/mysqld.conf away and rerun \`$0 init' (new config will be in $clusterdir)."
442                 exit 1
443         fi
444
445         if [ -f "$clusterdir/mysqld.conf" ]; then
446                 mysqlgetconfig "$clusterdir"
447         else
448                 MYSQL_USER="mysql"
449                 MYSQL_CLUSTER_DIR="$clusterdir"
450                 MYSQL_DATA_DIR="$clusterdir/mysqldb/db"
451                 MYSQL_PIDFILE="$clusterdir/mysqldb/mysql.pid"
452                 MYSQL_SOCKET="$clusterdir/mysqldb/mysql.sock"
453
454                 # this $MYSQL_CONFIG will be created later
455                 MYSQL_CONFIG="$MYSQL_CLUSTER_DIR/mysqld.conf"
456         fi
457
458         show "Initializing cluster %s" "$clusterdir"; started
459
460         # Check if not exist init database
461         if [ -d "$MYSQL_DATA_DIR/mysql" ]; then
462                 nls "Seems that database is initialized now. Remove by hand %s" "$MYSQL_DATA_DIR/mysql"
463                 nls "before initializing database."
464                 nls "For now skipping cluster %s." "$clusterdir"
465                 exit 6
466         fi
467
468         show "Installing MySQL system tables for $MYSQL_DATA_DIR"
469         busy
470         TMP=/tmp TMPDIR=/tmp
471
472         mkdir -p "$MYSQL_DATA_DIR" > /dev/null 2>&1
473         # Using mysql:mysql for MYSQL_CLUSTER_DIR is creating SECURITY hole, root:root is proper
474         chown root:root "$MYSQL_CLUSTER_DIR"
475         chown mysql:mysql "$MYSQL_CLUSTER_DIR/mysqldb" "$MYSQL_DATA_DIR" > /dev/null 2>&1
476         chmod 751 "$MYSQL_CLUSTER_DIR" "$MYSQL_CLUSTER_DIR/mysqldb"
477
478         if [ -f $sharedir/mysqld.conf -a ! -f "$MYSQL_CLUSTER_DIR/mysqld.conf" ]; then
479                 sed -e "
480                         s#\(datadir.*\)=.*#\1= $MYSQL_DATA_DIR#g;
481                         s#\(pid-file.*\)=.*#\1= $MYSQL_PIDFILE#g;
482                         s#\(socket.*\)=.*#\1= $MYSQL_SOCKET#g;
483                         s#@clusterdir@#$MYSQL_CLUSTER_DIR#g;
484                 " $sharedir/mysqld.conf > "$MYSQL_CLUSTER_DIR/mysqld.conf"
485                 chown root:root "$MYSQL_CLUSTER_DIR/mysqld.conf"
486                 chmod 640 "$MYSQL_CLUSTER_DIR/mysqld.conf"
487         fi
488
489         cat > $MYSQL_DATA_DIR/mysql-init.sql <<-EOF
490                 CREATE DATABASE mysql;
491                 use mysql;
492                 $(cat $sharedir/mysql_system_tables.sql)
493                 $(sed -e "/@current_hostname/d" $sharedir/mysql_system_tables_data.sql)
494 EOF
495
496         ok=0
497         /usr/sbin/mysqld \
498                 --defaults-file=$MYSQL_CLUSTER_DIR/mysqld.conf \
499                 --bootstrap \
500                 --skip-grant-tables \
501                 --datadir=$MYSQL_DATA_DIR \
502                 --user=$MYSQL_USER \
503                 --slave-load-tmpdir=$MYSQL_DATA_DIR \
504                 --tmpdir=$MYSQL_DATA_DIR \
505                 --log-error=$MYSQL_ERRLOG \
506                 < $MYSQL_DATA_DIR/mysql-init.sql && ok=1
507         [ -f $MYSQL_DATA_DIR/mysql/user.frm ] || ok=0
508
509         if [ "$ok" = 1 ]; then
510                 rm -f $MYSQL_DATA_DIR/mysql-init.sql
511                 ok
512                 cat << END_OF_MSG
513
514 PLEASE REMEMBER TO SET A PASSWORD FOR THE MySQL USERS!
515 This is done, after starting database, in the order shown,
516 with:
517
518 For 'mysql_sysadmin' (RELOAD and SHUTDOWN privileges):
519 echo "update mysql.user set password=password('newpassword') where user='mysql_sysadmin'; FLUSH PRIVILEGES;" | mysql -u mysql -S $MYSQL_SOCKET
520
521 For 'mysql' user (ALL privileges, DB admin):
522 echo "update mysql.user set password=password('newpassword') where user='mysql'; FLUSH PRIVILEGES;" | mysql -u mysql -S $MYSQL_SOCKET
523
524 NOTE: mysql_sysadmin password should be placed to $MYSQL_CONFIG in
525 mysqladmin section. See the manual for more instructions.
526 (This user is used at logs rotation and server shutdown)
527
528 END_OF_MSG
529                 show "Filling help tables..."
530                 ok=0
531                 ( echo "use mysql;"; cat $sharedir/fill_help_tables.sql ) | \
532                         /usr/sbin/mysqld \
533                         --defaults-file=$MYSQL_CLUSTER_DIR/mysqld.conf \
534                         --bootstrap \
535                         --skip-grant-tables \
536                         --datadir=$MYSQL_DATA_DIR \
537                         --user=$MYSQL_USER \
538                         --slave-load-tmpdir=$MYSQL_DATA_DIR \
539                         --tmpdir=$MYSQL_DATA_DIR \
540                         --log-error=$MYSQL_ERRLOG \
541                         && ok=1
542                 if [ "$ok" = 1 ]; then
543                         ok
544                 else
545                         cat << END_OF_MSG
546
547 WARNING: HELP FILES ARE NOT COMPLETELY INSTALLED!
548 The "HELP" command might not work properly.
549
550 END_OF_MSG
551                 fi
552         else
553                 fail
554                 cat << END_OF_MSG
555 ERROR:
556 ERROR:
557 ERROR: Installation of grant tables FAILED!
558 ERROR:
559 ERROR:
560
561 The initialization SQL script was preserved at $MYSQL_DATA_DIR/mysql-init.sql
562
563 Examine the logs in /var/log/mysql for more information. You can
564 also try to start the mysqld daemon with:
565
566 /usr/sbin/mysqld --skip-grant &
567
568 You can use the command line tool mysql to connect to the mysql
569 database and look at the grant tables:
570
571 shell> mysql -u mysql mysql
572 mysql> show tables
573
574 Try 'mysqld --help' if you have problems with paths. Setting on
575 logging in $MYSQL_DATA_DIR/mysqld.conf gives you a log in /var/log/mysql/query.log that
576 may be helpful. The latest information about MySQL is available on the
577 web at http://www.mysql.com/.
578
579 Please check PLD Linux ftp site for newer versions of this package.
580
581 Please consult the MySQL manual section: 'Problems running
582 mysql_install_db', and the manual section that describes problems on
583 your OS. Another information source is the MySQL email archive.
584
585 END_OF_MSG
586                 exit 1
587         fi
588
589         # if it's first server, register as default
590         if [ ! -e /var/lib/mysql/mysql.sock ] || [ -L /var/lib/mysql/mysql.sock ] && [ -z "$(readlink /var/lib/mysql/mysql.sock)" ]; then
591                 sock=${MYSQL_SOCKET#/var/lib/mysql/} # make it relative if possible
592                 ln -s "$sock" /var/lib/mysql/mysql.sock
593         fi
594         # same for config, move to /etc
595         if [ ! -e /etc/mysql/mysqld.conf ]; then
596                 mv "$MYSQL_CLUSTER_DIR/mysqld.conf" /etc/mysql/mysqld.conf
597         fi
598 }
599
600 #
601 # End of useful functions.
602 #
603
604 start() {
605         local mysqldir
606         for mysqldir in $DB_CLUSTERS; do
607                 mysqlstatus "$mysqldir" start
608                 if [ "$MYSQL_STATUS" = "running" ]; then
609                         msg_already_running "MySQL $mysqldir"
610                 else
611                         mysqlstart "$mysqldir"
612                 fi
613         done
614         mysqlsubsys
615 }
616
617 stop() {
618         local mysqldir
619         for mysqldir in $DB_CLUSTERS; do
620                 mysqlstatus "$mysqldir" stop
621                 if [ "$MYSQL_STATUS" = "not running" ]; then
622                         msg_not_running "MySQL $mysqldir"
623                 else
624                         mysqlstop "$mysqldir"
625                 fi
626         done
627         mysqlsubsys
628 }
629
630 condrestart() {
631         if [ ! -f /var/lock/subsys/mysql ]; then
632                 msg_not_running "MySQL"
633                 RETVAL=$1
634                 return
635         fi
636
637         stop
638         start
639 }
640
641 status() {
642         local mysqldir addr port socket pid pids running datadir 
643         RETVAL=3
644         for mysqldir in $DB_CLUSTERS; do
645                 mysqlstatus "$mysqldir"
646                 if [ "$MYSQL_STATUS" = "running" ]; then
647                         RETVAL=0
648                         addr=${MYSQL_BIND_ADDRESS:-0.0.0.0}
649                         port=${MYSQL_PORT:-3306}
650                         socket=${MYSQL_SOCKET:-/var/lib/mysql/mysql.sock}
651                         pid=$MYSQL_PID
652                         nls "MySQL cluster %s, pid %s\n" "$mysqldir" "$pid"
653                         [ -z "$MYSQL_SKIP_NETWORKING" ] && nls "\ttcp:%s:%s\n" "$addr" "$port"
654                         nls "\tunix: %s\n" "$socket"
655
656                         MYSQL_SOCKET=$socket slave_status
657
658                         pids="$pids/$MYSQL_PID/"
659                         progress "$MYSQL_STATUS"
660                 else
661                         show "MySQL cluster %s" "$mysqldir"
662                         progress "$MYSQL_STATUS" "$CFAIL"
663                 fi
664                 echo
665         done
666
667         for pid in $(/sbin/pidof mysqld); do
668                 if [[ $pids != */$pid/* ]]; then
669                         running="$running $pid"
670                 fi
671         done
672
673         if [ $# = 1 -a "$running" ]; then
674                 nls "Warning: MySQL Daemon processes not under clusters.conf control:"
675                 # see if we can display their status
676                 for pid in $running; do
677                         datadir=$(cat /proc/$pid/cmdline | tr '\0' '\n' | fgrep -- --datadir=)
678                         datadir=${datadir#--datadir=} # strip --datadir
679                         mysqldir=${datadir%/mysqldb/db} # strip /mysqldb/db
680                         mysqlstatus "$mysqldir"
681                         if [ "$MYSQL_STATUS" = "running" ]; then
682                                 addr=${MYSQL_BIND_ADDRESS:-0.0.0.0}
683                                 port=${MYSQL_PORT:-3306}
684                                 socket=${MYSQL_SOCKET:-/var/lib/mysql/mysql.sock}
685                                 nls "MySQL cluster %s, pid %s\n" "$mysqldir" "$pid"
686                                 [ -z "$MYSQL_SKIP_NETWORKING" ] && nls "\ttcp:%s:%s\n" "$addr" "$port"
687                                 nls "\tunix: %s\n" "$socket"
688
689                                 MYSQL_SOCKET=$socket slave_status
690
691                                 progress "$MYSQL_STATUS"
692                         else
693                                 show "MySQL cluster %s" "$mysqldir"
694                                 progress "$MYSQL_STATUS" "$CFAIL"
695                         fi
696                         echo
697                 done
698         fi
699 }
700
701 RETVAL=0
702 case "$action" in
703   start)
704         start
705         ;;
706   stop)
707         stop
708         ;;
709   restart)
710         stop
711         start
712         ;;
713   try-restart)
714         condrestart 0
715         ;;
716   force-reload)
717         condrestart 7
718         ;;
719   init)
720         for mysqldir in $DB_CLUSTERS; do
721                 mysqlinit "$mysqldir"
722         done
723         exit $?
724         ;;
725   flush-logs)
726         for mysqldir in $DB_CLUSTERS; do
727                 mysqlgetconfig "$mysqldir"
728                 # just if mysqld is really running
729                 if /usr/bin/mysqladmin --defaults-file="$MYSQL_CONFIG" --socket="$MYSQL_SOCKET" ping >/dev/null 2>&1; then
730                         /usr/bin/mysqladmin --defaults-file="$MYSQL_CONFIG" --socket="$MYSQL_SOCKET" flush-logs
731                 fi
732         done
733         ;;
734   status)
735         status
736         ;;
737   *)
738         msg_usage "$0 {start|stop|restart|try-restart|force-reload|init|flush-logs|status}"
739         exit 3
740 esac
741
742 exit $RETVAL
This page took 0.194389 seconds and 3 git commands to generate.